%undefine _hardened_build

Name:       gprbuild
Version:    2014
Release:    7.2%{?dist}
Summary:    Ada project builder
Group:      Development/Languages
License:    GPLv2+
URL:        http://libre.adacore.com
## Auth required
## Direct download is not available
Source0:    %{name}-gpl-%{version}-src.tar.gz
## Sources of gcc 5.1/gcc/ada directory
Source1:    gpprbuild-gcc_ada.tgz
# target patterns for Fedora's architectures:
Source2:    fedora_arches.xml
Patch0:     %{name}-%{version}-noopenvms.patch
Patch1:     %{name}-%{version}-iterator_variable.patch
Patch2:     %{name}-%{version}-destdir.patch
Patch3:     %{name}-%{version}-usrmove.patch
# Adapt to the changed version numbering scheme in GCC 5:
Patch4:	    %{name}-%{version}-gcc5.patch
# Fix a bug that throws away GCC options that begin with "-m":
Patch5:     %{name}-2014-m_options.patch
## Removing of OpenVMS references (not in gcc anymore)
## Replace version_string implementation with one from gnat 4.9
Patch6:     %{name}-%{version}-gcc5_sources.patch

BuildRequires:  xmlada-devel
BuildRequires:  gcc-gnat > 5.1
BuildRequires:  libgnat-static libgnat-devel
BuildRequires:  fedora-gnat-project-common >= 2
Requires:       fedora-gnat-project-common >= 2
Requires:       gnat-srpm-macros
# xmlada and gcc-gnat only available on these:
ExclusiveArch: %{GNAT_arches}

%description
GPRbuild is an advanced software tool designed to help automate
the construction of multi-language systems.
It removes complexity from multi-language development by allowing
developers to quickly and easily compile and link software written
in a combination of languages including Ada, Assembler, C, C++, and Fortran.
Easily extendable by users to cover new toolchains and languages
it is primarily aimed at projects of all sizes organized into subsystems
and libraries and is particularly well-suited for compiled languages.


%prep
%setup -q -n gprbuild-gpl-%{version}-src
mkdir gnat_src && tar -xf %{SOURCE1} -C gnat_src
%patch0 -p1
%patch1 -p1
%patch2 -p1 
%patch3 -p1 
%patch4 -p1
%patch5
%patch6 -p1

# Update the various config.guess to upstream release for new arch support
cp /usr/lib/rpm/config.* .

%build
%configure --disable-rpath --datadir="%{buildroot}/%{_datadir}" --libdir="%{buildroot}/%{_libdir}" --bindir="%{buildroot}/%{_bindir}" --libexecdir="%{buildroot}/%{_libexecdir}"
make copy_gnat_src
make %{?_smp_mflags} LIBRARY_TYPE="relocatable" GNATOPTFLAGS="%{Gnatmake_optflags}" ADA_PROJECT_PATH=%_GNAT_project_dir 

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
find %{buildroot}%{_datadir}/gprconfig -type f -name "*.xml" -exec chmod -x {} \;
# Add target patterns for Fedora's architectures.
cp %{SOURCE2} %{buildroot}%{_datadir}/gprconfig/
mkdir __doc
mv  %{buildroot}/%{_datadir}/doc/%{name}/* __doc
rm -rf %{buildroot}/%{_datadir}/doc/%{name} 
##%%find __doc/examples -type f -exec chmod -x {} \;

%files
%defattr(-,root,root,-)
%doc README COPYING* CHANGE*
%doc __doc/*
%{_bindir}/gpr*
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/gpr*
%dir %{_datadir}/gprconfig
%{_datadir}/gprconfig/*
%_GNAT_project_dir/*

%changelog
* Sat Apr 16 2016 Björn Persson <Bjorn@Rombobjörn.se> - 2014-7.2
- Restored the messed-up gcc5 patch.

* Sat Apr 16 2016 Björn Persson <Bjorn@Rombobjörn.se> - 2014-7.1
- Added target patterns to make GPRconfig recognize the native GCC on Fedora's
  secondary architectures.

* Sun May 24 2015 Pavel Zhukov  <landgraf@fedoraproject.org> - 2014-7
- Ship gnat 5.1 headers

* Mon May  4 2015 Peter Robinson <pbrobinson@fedoraproject.org> 2014-6
- Don't build ADA hardened

* Sat May 02 2015 Björn Persson <bjorn@rombobjörn.se> - 2014-5
- Fixed a bug that threw away GCC options that begin with "-m".

* Sun Mar 29 2015 Pavel Zhukov <landgraf@fedoraproject.org> - 2014-4
- New release (2014)
- Fix library version 

* Sun Feb 15 2015 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-16
- Remove OpenVMS from supported OS

* Sat Feb 14 2015 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-15
- Rebuild with new gcc 5.0

* Mon Nov 10 2014 Peter Robinson <pbrobinson@fedoraproject.org> 2013-14
- Update config.sub and config.guess for new architectures

* Sat Oct 11 2014 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-13
- Add gnat-srpm-macros as dependency
 
* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2013-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Mon Jun 09 2014 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-11
- Add arm to compillers list

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2013-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue May 13 2014 Peter Robinson <pbrobinson@fedoraproject.org> 2013-8
- Use GNAT_arches rather than an explicit list

* Wed May  7 2014 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-7
- Rebuild with new libgnat

* Mon Nov 18 2013 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-6
- Add fedora-gnat-project-common to the requires list

* Wed Sep 04 2013 Pavel Zhukov <landgraf@fedoraproject.org> - 2013-5
- changed http://fedoraproject.org/wiki/Changes/UnversionedDocdirs

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2013-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Jul 16 2013  Pavel Zhukov <landgraf@fedoraproject.org> - 2013-2
- rebuild with Fedora optflags (#984721)

* Sat Jul 13 2013  Pavel Zhukov <landgraf@fedoraproject.org> - 2013-1
- New release (2013)

* Fri Jan 25 2013   Pavel Zhukov <landgraf@fedoraproject.org> - 2012-4
- Rebuild with GCC 4.8 

* Tue Dec 18 2012  Pavel Zhukov <landgraf@fedoraproject.org> - 2012-3
- Rebuild for new xmlada

* Mon Dec 17 2012  Pavel Zhukov <landgraf@fedoraproject.org> - 2012-2
- Update to gprbuild 2012

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2011-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jun 21 2012 Julian Leyh <julian@vgai.de> - 2011-4
- Remove rpath from default configuration
- Make parsing of gcc version locale-independant

* Sun Mar 04 2012 Pavel Zhukov <landgraf@fedoraproject.org> - 2011-3
- Updated to 2011 (#722704)
- Add unreference patch

* Mon Feb 27 2012 Björn Persson <bjorn@rombobjörn.se> - 2011-1
- Patched to resolve the link /bin → /usr/bin.
- Removed a superfluous explicit dependency on xmlada.

* Sun Jul 17 2011 Pavel Zhukov <landgraf@fedoraproject.org> - 2010-10
- Rebuld for xmlada 2011

* Thu Mar 24 2011 Dan Horák <dan[at]danny.cz> - 2010-8
- updated the supported arch list
